package com.management.tzcontroller;

import com.alibaba.fastjson.JSONObject;
import com.management.utils.CaffeineCacheUtil;
import lombok.extern.slf4j.Slf4j;
import org.springframework.http.HttpEntity;
import org.springframework.http.HttpHeaders;
import org.springframework.web.client.RestClientException;
import org.springframework.web.client.RestTemplate;

import java.util.HashMap;
import java.util.Map;

@Slf4j
public class LedgerTokenController {

    private RestTemplate restTemplate = new RestTemplate();

    /**
    * 台账token获取
    * @return java.lang.String
    * @Author weiloong_zhang
    */
    public String getToken() {
        String token = "";

        if (CaffeineCacheUtil.get("ledgerToken") != null && !"".equals(CaffeineCacheUtil.get("ledgerToken"))) {
            log.info("台账token存在");
            token = CaffeineCacheUtil.get("ledgerToken").toString();
            return token;
        }

        log.info("台账token不存在，即将重新获取");

        //开始封装请求
        Map tokenParams = new HashMap<>();
        tokenParams.put("user", "equip");
        tokenParams.put("pwt", "E2Q0U2I5P0M5E1N2T");

        HttpHeaders headers = new HttpHeaders();
        headers.set("Content-Type", "application/json");

        HttpEntity tokenReqEntity = new HttpEntity(tokenParams, headers);

        //开始获取台账token
        JSONObject tokenRes = new JSONObject();

        try {
            tokenRes = restTemplate.postForObject("http://192.168.5.55:9011/equip/getToken", tokenReqEntity, JSONObject.class);
        } catch (RestClientException e) {
            e.printStackTrace();
        }

        if (tokenRes.getInteger("code") == 0 && !tokenRes.getJSONObject("data").isEmpty()) {
            token = tokenRes.getJSONObject("data").getString("token");

            CaffeineCacheUtil.put("ledgerToken", token);
        }

        return token;
    }
}
